#!/usr/bin/env python3
"""
dodgeball1.py
by Javantea
July 10, 2007
"""

from mod_python import apache

def index(req):
	from time import time
	
	req.content_type = "text/html"
	req.send_http_header()
	req.write("""<html>
	<head>
	<title>Dodgeball Map using Small Wide World</title>
	</head>
	<body>
	<h1>Dodgeball Map using Small Wide World</h1>
	<p style="width:640px;">
	This is a mashup of Dodgeball with 
	<a href="http://www.small-wide-world.com/">Small Wide 
	World</a> by AltSci Concepts. It uses mod_python to call the Python version 
	of Small Wide World. You can generate one map per five minutes. If you've 
	generated your map, feel free to <a href="http://www.small-wide-world.com/output/index.html">browse the 
	output</a> that you and others have created.
	</p>
	<p>
	<form action="/test/python/dodgeball1/" method="GET">""")
	url = req.form.getfirst('url')
	urld = url
	if urld == None:
		urld = 'http://www.dodgeball.com/user?uid=50882'
	#end if
	req.write("Dodgeball User URL: <br /><input type=\"text\" name=\"url\" value=\"" + str(urld) + "\" size=\"48\">")
	req.write("""<input type="submit" value="Generate">
	</form>
	</p>
	<br />""")
	if url == None:
		req.write("<div style='border:2px solid #6666ff; width:500px; height:500px;'>&nbsp;</div>")
	else:
		req.write("<embed src=\"/test/python/dodgeball1/svg?url=" + url + "&seed=" + str(int(time())) + "\" height=\"500\" width=\"500\" />")
	#end if
	req.write("<p>" + str(req.connection.remote_addr) + "</p>")
	req.write("""</body>
	</html>""")
#end def index(req)

def svg(req):
	from sys import path
	path.append('/home/www/altsci/test/python/smallwideworld')
	import sww_limit1
	if sww_limit1.sww_limit1(req.connection.remote_addr[0]) == False:
		#req.content_type = "image/svg+xml"
		#req.send_http_header()
		# <svg width='480' height='320'><text x='15' y='15'>
		# </text><text x='15' y='35'>
		# </text></svg>
		return "Sorry, no can do. Wait 5 minutes.\nPlease consider buying Small Wide World for full use.\n"
	#end if
	#return str(path)
	seed = req.form.getfirst('seed')
	if seed == '':
		from time import time
		seed = str(int(time()))
	#end if
	url = req.form.getfirst('url')
	from os import chdir
	chdir('/home/www/altsci/test/python/')
	import friendmap2
	if url == None or url == '':
		filename = 'data/dodge_jav1.html'
		dbu_id = 0
	else:
		import re
		urlm = re.search(r'(/user\?uid=[0-9]+)', url)
		if urlm == None: return 'Sorry, url "' + str(url) + '" failed.'
		urlf = urlm.groups()[0]
		b = re.search(r'([0-9]+)', urlf)
		if b == None: return 'Sorry, url "' + str(url) + '", "' + str(urlf) + '" failed.'
		dbu_id = b.groups()[0]
		filename = 'data/dbu_' + str(dbu_id) + '.html'
		try:
			import urllib.request, urllib.error, urllib.parse
			data = urllib.request.urlopen('http://www.dodgeball.com' + urlf).read()
			open(filename, 'wb').write(data)
		except urllib.error.URLError as e:
			#print 'Warning: Could not grab dodgeball friend', url, ':', e
			#skip over adding this friend's friends.
			return 'Warning: Could not grab dodgeball friend' + str(urlf) + ':' + str(e)
		#end try
	#end if
	m = friendmap2.FriendMap(filename, seed, 1)
	
	#m.sort3()
	#for i in range(3):
	#	m.sort2()
	#	m.sort4()
	#next i
	m.center()
	svg = str(m)
	if (dbu_id > 0):
		sww_limit1.sww_index1('output/dbu_' + str(dbu_id) + '.svg', svg, 'Dodgeball User ' + str(dbu_id))
	#end if
	req.content_type = "image/svg+xml"
	req.send_http_header()
	return svg
#end def svg(req)

def test():
	return 'tested'
#end def test()

