#!/usr/bin/env python

"""
myspace1.py
by Javantea
Sept 14, 2007
"""

from mod_python import apache

def index(req):
	from time import time
	
	req.content_type = "text/html"
	req.send_http_header()
	req.write("""<html>
	<head>
	<title>MySpace Map using Small Wide World</title>
	</head>
	<body>
	<h1>MySpace Map using Small Wide World</h1>
	<p style="width:640px;">
	This is a mashup of MySpace with 
	<a href="http://www.small-wide-world.com/">Small Wide 
	World</a> by AltSci Concepts. It uses mod_python to call the Python version 
	of Small Wide World. You can generate one map per five minutes. If you've 
	generated your map, feel free to <a href="http://www.small-wide-world.com/output/index.html">browse the 
	output</a> that you and others have created.
	</p>
	<p>
	<form action="/test/python/myspace1/" method="GET">""")
	url = req.form.getfirst('url')
	urld = url
	if urld == None:
		urld = 'http://www.myspace.com/altsci'
	#end if
	req.write("Myspace User URL: <br /><input type=\"text\" name=\"url\" value=\"" + str(urld) + "\" size=\"48\">")
	req.write("""<input type="submit" value="Generate">
	</form>
	</p>
	<br />""")
	if url == None:
		req.write("<div style='border:2px solid #6666ff; width:800px; height:600px;'>&nbsp;</div>")
	else:
		req.write("<iframe src=\"/test/python/myspace1/svg?url=" + url + "&seed=" + str(int(time())) + "\" width=\"800\" height=\"600\" />")
	#end if
	req.write("<p>" + str(req.connection.remote_addr) + "</p>")
	req.write("""</body>
	</html>""")
#end def index(req)

def svg(req):
	from sys import path
	path.append('/home/www/altsci/test/python/smallwideworld')
	import sww_limit1
	if sww_limit1.sww_limit1(req.connection.remote_addr[0]) == False:
		#req.content_type = "image/svg+xml"
		#req.send_http_header()
		# <svg width='480' height='320'><text x='15' y='15'>
		# </text><text x='15' y='35'>
		# </text></svg>
		url = req.form.getfirst('url')
		mysi_id = getMySpaceId(url)
		req.content_type = "text/html"
		req.headers_out['Location'] = 'http://www.small-wide-world.com/output/mysu_' + str(mysi_id) + '.svg'
		req.send_http_header()
		#req.write("<html><body></body></html>")
		raise apache.SERVER_RETURN(apache.HTTP_MOVED_TEMPORARILY)
		#return "Sorry, no can do. Wait 5 minutes.\nPlease consider buying Small Wide World for full use.\n"
	#end if
	#return str(path)
	seed = req.form.getfirst('seed')
	if seed == '':
		from time import time
		seed = str(int(time()))
	#end if
	url = req.form.getfirst('url')
	from os import chdir
	chdir('/home/www/altsci/test/python/')
	import myspacemap1
	if url == None or url == '':
		filename = 'data/mdmisgovernment.html'
		mysi_id = 'mdmisgovernment'
		urlf = mysi_id
	else:
		mysi_id = getMySpaceId(url)
		filename = 'data/mysui_' + str(mysi_id) + '.html'
		urlf = mysi_id
		try:
			import urllib.request, urllib.error, urllib.parse
			data = urllib.request.urlopen('http://www.myspace.com/' + urlf).read()
			open(filename, 'wb').write(data)
		except urllib.error.URLError as e:
			#print 'Warning: Could not grab dodgeball friend', url, ':', e
			#skip over adding this friend's friends.
			return 'Warning: Could not grab myspace friend' + str(urlf) + ':' + str(e)
		#end try
	#end if
	m = myspacemap1.MyspaceMap(filename, '/' + urlf, seed, 1)
	
	#m.sort3()
	#for i in range(3):
	#	m.sort2()
	#	m.sort4()
	#next i
	m.center()
	svg = str(m)
	if (mysi_id != ''):
		try:
			sww_limit1.sww_index1('output/mysu_' + str(mysi_id) + '.svg', svg, 'MySpace User ' + str(mysi_id))
		except Exception as e:
			svg += '<!-- Error writing file. -->'
		#end try
	#end if
	req.content_type = "image/svg+xml"
	req.send_http_header()
	return svg
#end def svg(req)

def getMySpaceId(url):
	import re
	urlm = re.search(r'myspace.com/([A-Za-z0-9]+)', url)
	if urlm == None: return 'Sorry, url "' + str(url) + '" failed.'
	urlf = urlm.groups()[0]
	return urlf
	#b = re.search(r'([A-Za-z0-9]+)', urlf)
	#if b == None: return 'Sorry, url "' + str(url) + '", "' + str(urlf) + '" failed.'
	#mysi_id = b.groups()[0]
	#return mysi_id
#end def getMySpaceId(url)

def test():
	return 'tested'
#end def test()

