#!/usr/bin/env python

"""
sww1.py
by Javantea
July 4, 2007
"""

from mod_python import apache

def index(req):
  from time import time
    
  req.content_type = "text/html"
  req.send_http_header()
  req.write("""<html>
  <head>
  <title>Small Wide World Test using mod Python</title>
  </head>
  <body>
  <h1>Small Wide World Test</h1>
  <p style="width:640px;">
  This is a test of <a href="http://www.small-wide-world.com/">Small Wide 
  World</a> by AltSci Concepts. It uses mod_python to call the Python version 
  of Small Wide World. Feel free to 
  <a href="/test/python/test1/">refresh the page</a> to get a new 
  drawing.
  </p>
  <br />""")
  req.write("<embed src=\"/test/python/test1/svg?seed=" + str(int(time())) + "\" height=\"480\" width=\"640\" />")
  req.write("<p>" + str(req.connection.remote_addr) + "</p>")
  req.write("""</body>
  </html>""")
#end def index(req)                            

def svg(req):
  from sys import path
  path.append('/home/www/altsci/test/python/smallwideworld')
  #return str(path)
  seed = req.form.getfirst('seed')
  if seed == '':
    from time import time
    seed = str(int(time()))
  #end if
  import mapmake1
  m = mapmake1.createMap(seed) #time())
  #m.sort3()
  for i in range(3):
    m.sort2()
    m.sort4()
  #next i
  m.center()
  svg = str(m)
  req.content_type = "image/svg+xml"
  req.send_http_header()
  return svg
#end def svg(req)
  
def test():
  return 'tested'
#end def test()

