%module sww_cpp

%include "std_string.i"
%include "std_vector.i"
%include "cpointer.i"
%include "carrays.i"
%pointer_class(int, intp);
%pointer_class(unsigned int, GLuintp);
%pointer_class(uint8_t, bytep);
%array_class(int, intArray);
%array_class(char, charArray);
%array_class(uint8_t, byteArray);
%array_class(float, floatArray);

%include "sww.h"

%{
#include "sww.h"
%}

%template(IntVector) std::vector<int>;
%template(ConnListV) std::vector<Conns>;

%{

class LJ_Potential {
	public:
	float r0;
	float scale_factor;
	float A;
	float B;
	LJ_Potential(float r0_init=40, float scale_factor_init=0.055);
	~LJ_Potential();
	float V_LJ(float r);
};

float V_SmallWideWorld(float *x, ConnList *conns, float b0, LJ_Potential *lj_conf, ConnList *nonConns);

%}

//%pointer_class(ConnList, ConnListp);

class LJ_Potential {
	public:
	float r0;
	float scale_factor;
	float A;
	float B;
	LJ_Potential(float r0_init=40, float scale_factor_init=0.055);
	~LJ_Potential();
	float V_LJ(float r);
};

float V_SmallWideWorld(float *x, ConnList *conns, float b0, LJ_Potential *lj_conf, ConnList *nonConns);

